macroScript GLBBox 
buttontext:"Collision Generator..." category:"GLBasic"
(
	rollout CGenerator "Collision Generator" width:200 height:240
	(
	
		
		button btnCancel "Cancel" pos:[8,256] width:88 height:24
		button btnBSphere "Create BSphere" pos:[104,256] width:88 height:24
		groupBox grp2 "Collision Options" pos:[8,8] width:184 height:104
		label lbl4 "Sphere Segments:" pos:[32,32] width:88 height:19
		spinner SpSeg "" pos:[128,32] width:56 height:16 range:[4,25,8] scale: 1 type:#integer
		groupBox grp4 "Export Progress" pos:[8,120] width:184 height:96
		
		label lbl11 "Current Object:" pos:[16,136] width:72 height:16
		label lbl12 "Total Scene:" pos:[16,176] width:72 height:16
		
		progressBar pbCurrent "" pos:[16,192] width:168 height:16 color:(color 81 153  251)
		progressBar pbTotal "" pos:[16,152] width:168 height:16 color:(color 81 153  251)
		
		button btnAbout "About" pos:[8,224] width:88 height:24
		
		label lblPercentC "0%" pos:[90,136] width:48 height:16
		label lblPercentT "0%" pos:[80,176] width:48 height:16
		
		button btnBBox "Create BBox" pos:[104,224] width:88 height:24
		label lbl36 "Object Name Posfix" pos:[16,56] width:96 height:16
		
		editText edtPostfix "" pos:[16,72] width:168 height:17 text:"_Collision"
		
		on btnCancel pressed do
		(
			destroyDialog(CGenerator)
		)
		--	buttontext:"About..."
		on btnAbout pressed do
		(
			
			(
			rollout AboutGLBasic "About" width:296 height:152
				(	 
					bitmap bmp1 "Bitmap" pos:[8,8] width:280 height:80 fileName: "GLLogo01.bmp" 
					button btn1 "Ok" pos:[104,140] width:88 height:24
					label lbl13 "CDDL Common Development and Distribution License, 2011 develop by Alexey Vlasov" pos:[10,96] width:275 height:30 align:#right style_sunkenedge:true
					on btn1 pressed do destroyDialog(AboutGLBasic)
				)
				
				createDialog AboutGLBasic 296 172
			)
		)
		
		-- Bounding Box Generator
		on btnBBox pressed do
		(
			
			if (selection.count > 0) then
			(	
				a = 0
				for Obj in selection do
				(
					local tmesh = snapshotAsMesh obj
					
					--Cheking Face Present
					if (tmesh.numfaces > 0) then
					(	
						--initial size BBox
						vert = getVert tmesh 1
						
						local bb_px = vert.x
						local bb_py = vert.y
						local bb_pz = vert.z
						
						local bb_nx = vert.x
						local bb_ny = vert.y
						local bb_nz = vert.z
						
						-- Calculating maximum positive and negative x,y,z
						for v = 1 to tmesh.numverts do
						(
							vert = getVert tmesh v
							
							-- positive
							if (vert.x > bb_px ) then (bb_px = vert.x)
							if (vert.y > bb_py ) then (bb_py = vert.y)
							if (vert.z > bb_pz ) then (bb_pz = vert.z)
							
							--negative
							if (vert.x < bb_nx ) then (bb_nx = vert.x)
							if (vert.y < bb_ny ) then (bb_ny = vert.y)
							if (vert.z < bb_nz ) then (bb_nz = vert.z)
							
							--UpdateProgressBar
						pbTotal.value = 100.*v/tmesh.numverts
						lblPercentC.caption = "Vert " + pbTotal.value as string +"%"
							
						)
						
						pbTotal.value = 0
						lblPercentC.caption = "Done!"
						
						BBph = Box length:(bb_py - bb_ny) width:(bb_px - bb_nx) height:(bb_pz - bb_nz) lengthsegs:1 widthsegs:1 heightsegs:1 mapcoords:on pos:[ (bb_px - bb_nx)/2+bb_nx, (bb_py - bb_ny)/2+bb_ny ,bb_nz] 
						
						--Assign new name to collision Object
						NName = Obj.name + edtPostfix.text
						BBph.name = NName
						BBph.xray = on
						BBph.vertexTicks = on
						
						--Update Total in Selection Objects ProgressBar
						a = a+1
						b = selection
						pbCurrent.value = 100.*a/b.count
						lblPercentT.caption = "Vert " + pbCurrent.value as string +"%"
						
					)
					else
					(
						messagebox ("Object with name \"" + obj.name + "\" not have faces! Fix it!") title: "Warning!"
					)
					
				)
			)
			else
			(
				messagebox ("Select any Objects for Bounding Box generation!") title: "Warning!"
			)
			
			pbCurrent.value = 0
			lblPercentT.caption = "Done!"
		)
		
		-- Bounding Box Sphere
		on btnBSphere pressed do
		(
			
			if (selection.count > 0) then
			(	
				a = 0
				for Obj in selection do
				(
					local tmesh = snapshotAsMesh obj
					
					--Cheking Face Present
					if (tmesh.numfaces > 0) then
					(	
						--initial size BBox
						vert = getVert tmesh 1
						
						local bb_px = vert.x
						local bb_py = vert.y
						local bb_pz = vert.z
						
						local bb_nx = vert.x
						local bb_ny = vert.y
						local bb_nz = vert.z
						
						-- Calculating maximum positive and negative x,y,z
						for v = 1 to tmesh.numverts do
						(
							vert = getVert tmesh v
							
							-- positive
							if (vert.x > bb_px ) then (bb_px = vert.x)
							if (vert.y > bb_py ) then (bb_py = vert.y)
							if (vert.z > bb_pz ) then (bb_pz = vert.z)
							
							--negative
							if (vert.x < bb_nx ) then (bb_nx = vert.x)
							if (vert.y < bb_ny ) then (bb_ny = vert.y)
							if (vert.z < bb_nz ) then (bb_nz = vert.z)
							
							--UpdateProgressBar
						pbTotal.value = 100.*v/tmesh.numverts
						lblPercentC.caption = "Vert " + pbTotal.value as string +"%"
							
						)
						
						pbTotal.value = 0
						lblPercentC.caption = "Done!"
						
						--Calculate max object Size For Bsphere
						MaxValue = #(bb_px - bb_nx , bb_py - bb_ny , bb_pz - bb_nz )
						
						local SSize = 0
						for f = 1 to MaxValue.count do
						(
							if MaxValue[f] > SSize then SSize = MaxValue[f]
						)
						
						BSph = Sphere  pos:[ (bb_px - bb_nx)/2+bb_nx, (bb_py - bb_ny)/2+bb_ny ,(bb_pz - bb_nz)/2+bb_nz] Radius: (SSize/2) segs:SpSeg.value
						
						--Assign new name to collision Object
						NName = Obj.name + edtPostfix.text
						BSph.name = NName
						BSph.xray = on
						BSph.vertexTicks = on
						
						--Update Total in Selection Objects ProgressBar
						a = a+1
						b = selection
						pbCurrent.value = 100.*a/b.count
						lblPercentT.caption = "Vert " + pbCurrent.value as string +"%"
				
					)
					
					
					else
					(
						messagebox ("Object with name \"" + obj.name + "\" not have faces! Fix it!") title: "Warning!"
					)
			
				)
			)
			else
			(
				messagebox ("Select any Objects for Bounding Box generation!") title: "Warning!"
			)
			
			pbCurrent.value = 0
			lblPercentT.caption = "Done!"
		)
	)
	
	createDialog CGenerator 200 288
)




macroScript GLBasicExport
	buttontext:"Export..." category:"GLBasic"
(

global NList = #(-0.525731, 0.000000, 0.850651,
-0.442863, 0.238856, 0.864188,
-0.295242, 0.000000, 0.955423,
-0.309017, 0.500000, 0.809017,
-0.162460, 0.262866, 0.951056,
0.000000, 0.000000, 1.000000,
0.000000, 0.850651, 0.525731,
-0.147621, 0.716567, 0.681718,
0.147621, 0.716567, 0.681718,
0.000000, 0.525731, 0.850651,
0.309017, 0.500000, 0.809017,
0.525731, 0.000000, 0.850651,
0.295242, 0.000000, 0.955423,
0.442863, 0.238856, 0.864188,
0.162460, 0.262866, 0.951056,
-0.681718, 0.147621, 0.716567,
-0.809017, 0.309017, 0.500000,
-0.587785, 0.425325, 0.688191,
-0.850651, 0.525731, 0.000000,
-0.864188, 0.442863, 0.238856,
-0.716567, 0.681718, 0.147621,
-0.688191, 0.587785, 0.425325,
-0.500000, 0.809017, 0.309017,
-0.238856, 0.864188, 0.442863,
-0.425325, 0.688191, 0.587785,
-0.716567, 0.681718, -0.147621,
-0.500000, 0.809017, -0.309017,
-0.525731, 0.850651, 0.000000,
0.000000, 0.850651, -0.525731,
-0.238856, 0.864188, -0.442863,
0.000000, 0.955423, -0.295242,
-0.262866, 0.951056, -0.162460,
0.000000, 1.000000, 0.000000,
0.000000, 0.955423, 0.295242,
-0.262866, 0.951056, 0.162460,
0.238856, 0.864188, 0.442863,
0.262866, 0.951056, 0.162460,
0.500000, 0.809017, 0.309017,
0.238856, 0.864188, -0.442863,
0.262866, 0.951056, -0.162460,
0.500000, 0.809017, -0.309017,
0.850651, 0.525731, 0.000000,
0.716567, 0.681718, 0.147621,
0.716567, 0.681718, -0.147621,
0.525731, 0.850651, 0.000000,
0.425325, 0.688191, 0.587785,
0.864188, 0.442863, 0.238856,
0.688191, 0.587785, 0.425325,
0.809017, 0.309017, 0.500000,
0.681718, 0.147621, 0.716567,
0.587785, 0.425325, 0.688191,
0.955423, 0.295242, 0.000000,
1.000000, 0.000000, 0.000000,
0.951056, 0.162460, 0.262866,
0.850651, -0.525731, 0.000000,
0.955423, -0.295242, 0.000000,
0.864188, -0.442863, 0.238856,
0.951056, -0.162460, 0.262866,
0.809017, -0.309017, 0.500000,
0.681718, -0.147621, 0.716567,
0.850651, 0.000000, 0.525731,
0.864188, 0.442863, -0.238856,
0.809017, 0.309017, -0.500000,
0.951056, 0.162460, -0.262866,
0.525731, 0.000000, -0.850651,
0.681718, 0.147621, -0.716567,
0.681718, -0.147621, -0.716567,
0.850651, 0.000000, -0.525731,
0.809017, -0.309017, -0.500000,
0.864188, -0.442863, -0.238856,
0.951056, -0.162460, -0.262866,
0.147621, 0.716567, -0.681718,
0.309017, 0.500000, -0.809017,
0.425325, 0.688191, -0.587785,
0.442863, 0.238856, -0.864188,
0.587785, 0.425325, -0.688191,
0.688191, 0.587785, -0.425325,
-0.147621, 0.716567, -0.681718,
-0.309017, 0.500000, -0.809017,
0.000000, 0.525731, -0.850651,
-0.525731, 0.000000, -0.850651,
-0.442863, 0.238856, -0.864188,
-0.295242, 0.000000, -0.955423,
-0.162460, 0.262866, -0.951056,
0.000000, 0.000000, -1.000000,
0.295242, 0.000000, -0.955423,
0.162460, 0.262866, -0.951056,
-0.442863, -0.238856, -0.864188,
-0.309017, -0.500000, -0.809017,
-0.162460, -0.262866, -0.951056,
0.000000, -0.850651, -0.525731,
-0.147621, -0.716567, -0.681718,
0.147621, -0.716567, -0.681718,
0.000000, -0.525731, -0.850651,
0.309017, -0.500000, -0.809017,
0.442863, -0.238856, -0.864188,
0.162460, -0.262866, -0.951056,
0.238856, -0.864188, -0.442863,
0.500000, -0.809017, -0.309017,
0.425325, -0.688191, -0.587785,
0.716567, -0.681718, -0.147621,
0.688191, -0.587785, -0.425325,
0.587785, -0.425325, -0.688191,
0.000000, -0.955423, -0.295242,
0.000000, -1.000000, 0.000000,
0.262866, -0.951056, -0.162460,
0.000000, -0.850651, 0.525731,
0.000000, -0.955423, 0.295242,
0.238856, -0.864188, 0.442863,
0.262866, -0.951056, 0.162460,
0.500000, -0.809017, 0.309017,
0.716567, -0.681718, 0.147621,
0.525731, -0.850651, 0.000000,
-0.238856, -0.864188, -0.442863,
-0.500000, -0.809017, -0.309017,
-0.262866, -0.951056, -0.162460,
-0.850651, -0.525731, 0.000000,
-0.716567, -0.681718, -0.147621,
-0.716567, -0.681718, 0.147621,
-0.525731, -0.850651, 0.000000,
-0.500000, -0.809017, 0.309017,
-0.238856, -0.864188, 0.442863,
-0.262866, -0.951056, 0.162460,
-0.864188, -0.442863, 0.238856,
-0.809017, -0.309017, 0.500000,
-0.688191, -0.587785, 0.425325,
-0.681718, -0.147621, 0.716567,
-0.442863, -0.238856, 0.864188,
-0.587785, -0.425325, 0.688191,
-0.309017, -0.500000, 0.809017,
-0.147621, -0.716567, 0.681718,
-0.425325, -0.688191, 0.587785,
-0.162460, -0.262866, 0.951056,
0.442863, -0.238856, 0.864188,
0.162460, -0.262866, 0.951056,
0.309017, -0.500000, 0.809017,
0.147621, -0.716567, 0.681718,
0.000000, -0.525731, 0.850651,
0.425325, -0.688191, 0.587785,
0.587785, -0.425325, 0.688191,
0.688191, -0.587785, 0.425325,
-0.955423, 0.295242, 0.000000,
-0.951056, 0.162460, 0.262866,
-1.000000, 0.000000, 0.000000,
-0.850651, 0.000000, 0.525731,
-0.955423, -0.295242, 0.000000,
-0.951056, -0.162460, 0.262866,
-0.864188, 0.442863, -0.238856,
-0.951056, 0.162460, -0.262866,
-0.809017, 0.309017, -0.500000,
-0.864188, -0.442863, -0.238856,
-0.951056, -0.162460, -0.262866,
-0.809017, -0.309017, -0.500000,
-0.681718, 0.147621, -0.716567,
-0.681718, -0.147621, -0.716567,
-0.850651, 0.000000, -0.525731,
-0.688191, 0.587785, -0.425325,
-0.587785, 0.425325, -0.688191,
-0.425325, 0.688191, -0.587785,
-0.425325, -0.688191, -0.587785,
-0.587785, -0.425325, -0.688191,
-0.688191, -0.587785, -0.425325
)

global EscapeEnable = true
	
global OpenPath = undefined
global SavePath = undefined



rollout ExportGLBasic "Export: Settings" width:200 height:536
(		
	
		button btnCancel "Cancel" pos:[8,552] width:88 height:24
		button btnExport "Export" pos:[104,552] width:88 height:24
		groupBox grp1 "BatchExport" pos:[8,240] width:184 height:168
		label lbl1 "Input Path" pos:[16,312] width:96 height:16
		editText edtInput "" pos:[16,328] width:128 height:20 text: "Select Path..." readonly: true
		editText edtOutput "" pos:[16,376] width:128 height:20 text: "Select Path..." readonly: true
		label lbl2 "Output Path" pos:[16,360] width:96 height:16
		button btnInput "..." pos:[153,328] width:32 height:24
		button btnOutput "..." pos:[152,376] width:32 height:24
		groupBox grp2 "Animation" pos:[8,160] width:184 height:72
		checkbox chkCopy "Checkbox" pos:[16,56] width:16 height:16
		label lbl3 "Export Animation" pos:[40,184] width:144 height:24
		label lbl4 "Every Nth Frame:" pos:[32,208] width:88 height:19
		groupBox grp3 "Scene Options" pos:[8,8] width:184 height:144
		checkbox chkSObj "Checkbox" pos:[16,32] width:16 height:16
		label lbl5 "Export Only Selected Objects" pos:[41,32] width:144 height:24
		label lbl6 "Copy Texture to Models" pos:[40,56] width:144 height:24
		
		checkbox chkWrld "Checkbox" pos:[16,104] width:16 height:16
		label lbl9 "Export World File" pos:[40,104] width:144 height:19
		
		checkbox chkWarn "Checkbox" pos:[16,80] width:16 height:16
		label lbl8 "Disable Warnings" pos:[40,80] width:144 height:24
		
		label lbl7 "ASCII Export Mode" pos:[40,128] width:144 height:19
		checkbox chkASC "Checkbox" pos:[16,128]  width:16 height:16 
		--enabled:false
		
		
		
		spinner NthFrame "" pos:[128,208] width:56 height:16 range:[1,100,1] scale: 1 type:#integer
		checkbox chkAnimExp "Checkbox" pos:[16,184] width:16 height:16
		checkbox chkBachExp "Checkbox" pos:[16,264] width:16 height:16
		label lbl10 "Batch Mode" pos:[42,264] width:104 height:16
		groupBox grp4 "Export Progress" pos:[8,416] width:184 height:96
		progressBar pbTotal "" pos:[16,448] width:168 height:16 color:(color 81 153 251)
		label lbl11 "Total:" pos:[17,432] width:96 height:16
		label lbl12 "Current Scene:" pos:[16,472] width:96 height:16
		progressBar pbCurrent "" pos:[16,488] width:168 height:16 color:(color 81 153 251)
		
		button btnAbout "About" pos:[8,520] width:88 height:24
		checkbox chkSubFldr "Checkbox" pos:[16,288] width:16 height:16
		label lbl13 "Include SubFolders" pos:[40,288] width:104 height:16
		label lblPercentT "0%" pos:[48,432] width:95 height:16
		label lblPercentS "0%" pos:[92,472] width:95 height:16
		
		button btnSaveSet "SaveSettings" pos:[104,520] width:88 height:24
		
	
		
		-- Write INI file FUNCTION
		
		fn WriteIniFun = (
		
			local IniFileName = (GetDir #startupScripts) + "/GLBasic.ini"
	
			--if ((getfiles IniFilename).count == 0) then (

			--ini file not exist create default settings
	
			local IniFile = Createfile IniFileName 
			
			format "%\n" chkASC.checked  to:IniFile
			format "%\n" chkASC.enabled  to:IniFile
			
			format "%\n" chkCopy.checked  to:IniFile
			format "%\n" chkCopy.enabled  to:IniFile
			
			format "%\n" chkSObj.checked  to:IniFile
			format "%\n" chkSObj.enabled  to:IniFile
			
			format "%\n" chkWarn.checked  to:IniFile
			format "%\n" chkWarn.enabled  to:IniFile
			
			format "%\n" chkWrld.checked  to:IniFile
			format "%\n" chkWrld.enabled  to:IniFile
		
			format "%\n" chkAnimExp.checked  to:IniFile
			format "%\n" chkAnimExp.enabled  to:IniFile
			
			format "%\n" chkBachExp.checked  to:IniFile
			format "%\n" chkBachExp.enabled  to:IniFile
			
			format "%\n" chkSubFldr.checked  to:IniFile
			format "%\n" chkSubFldr.enabled  to:IniFile
			
			format "%\n" OpenPath  to:IniFile
			format "%\n" SavePath  to:IniFile
			
			format "%\n" edtInput.text  to:IniFile
			format "%\n" edtOutput.text  to:IniFile
			
			format "%\n" NthFrame.range  to:IniFile
			
			close IniFile
			
			return IniFile
		)


		on btnSaveSet pressed do (
		
			WriteIniFun()
			
		)
		
		on ExportGLBasic open do (
			
			local IniFileName = (GetDir #startupScripts) + "/GLBasic.ini"
	
			if ((getfiles IniFilename).count == 0) then (

			--ini file not exist create default settings
	
			WriteIniFun()
			
			)
		else (

		-- ini file exist and read settings from it
			IniFile = openfile IniFileName
			
			chkASC.checked = ReadValue IniFile
			chkASC.enabled = ReadValue IniFile
			
			chkCopy.checked = ReadValue IniFile
			chkCopy.enabled = ReadValue IniFile
			
			chkSObj.checked = ReadValue IniFile
			chkSObj.enabled = ReadValue IniFile
			
			chkWarn.checked = ReadValue IniFile
			chkWarn.enabled = ReadValue IniFile
			
			chkWrld.checked = ReadValue IniFile
			chkWrld.enabled = ReadValue IniFile
			
			chkAnimExp.checked = ReadValue IniFile
			chkAnimExp.enabled = ReadValue IniFile
			
			chkBachExp.checked = ReadValue IniFile
			chkBachExp.enabled = ReadValue IniFile
			
			chkSubFldr.checked = ReadValue IniFile
			chkSubFldr.enabled = ReadValue IniFile
			
			OpenPath = ReadLine IniFile
			SavePath = ReadLine IniFile
			
			edtInput.text = ReadLine IniFile
			edtOutput.text = ReadLine IniFile
			
			NthFrame.range = ReadExpr IniFile
			
			close IniFile
	
		)
		
		)
	
				
		on btnCancel pressed do destroyDialog(ExportGLBasic)
	
		on btnAbout pressed do (
			
			--	buttontext:"About..." category:"GLBasic"
			(
			rollout AboutGLBasic "About" width:296 height:152
				(	 
				bitmap bmp1 "Bitmap" pos:[8,8] width:280 height:80 fileName: "GLLogo01.bmp" 
				button btn1 "Ok" pos:[104,140] width:88 height:24
				label lbl13 "CDDL Common Development and Distribution License, 2011 develop by Alexey Vlasov" pos:[10,96] width:275 height:30 align:#right style_sunkenedge:true
				on btn1 pressed do destroyDialog(AboutGLBasic)
				)
			createDialog AboutGLBasic 296 172
			)
		)
		
		on chkBachExp changed theState do (
			
			if (chkBachExp.checked == true) then(
				--chkASC.enabled = false
				chkASC.checked = false
				
				chkSObj.enabled = false
				chkSObj.checked = false
				
				chkWrld.enabled = false
				chkWrld.checked = true
				
				--chkWarn.enabled = false
				chkWarn.checked = true
				
				chkSubFldr.checked = true
				
				chkCopy.checked = true
				
				chkAnimExp.checked = true
			)
			else (
				chkASC.enabled = true
				chkSObj.enabled = true
				chkWrld.enabled = true
				chkWarn.enabled = true
			)
		)
		

		
		-- Main Scene Export FUNCTION
			fn MainExport = (
				
				disableSceneRedraw()
				
			-- Array with texture path used for The current scene.
			local STex = #()
			local SObjNm =#()
			local SObjDiff =#()
			local SObjBump =#()
				
			if (chkSObj.checked == false) then (max select all)
				
				local AnimEnd = animationRange.end
			
				-- If Animation Export Checked from GIU then Export Animated Vertex
				if (chkAnimExp.checked == false) then (AnimEnd = animationRange.start)
				
				-- Check if Object exist in to Scene do
				if (selection.count > 0) then (
					
					for obj in selection do (
						
						--Check material asigment and if "undifined" skip to processing
						
						if (obj.material != undefined) then (
						
							--Get object MaterialType Name as string
							local Nmb = obj.material as string
							local MtlPos = findstring Nmb ":"
							local MtlName = ""
							
							-- Trim only "ObjMaterial Type" as string
							for i = MtlPos+1 to Nmb.count do (
								MtlName = MtlName + Nmb[i] 	
							)
						
						-- Check Obj Standart material asigment
						if (MtlName == "Standard" ) then (
							
						local tmesh = snapshotAsMesh obj
						
						--Remove isolated Vertixs for fix UV points Indexes(reduse file size).
						--may be add in future release
						
						
						if (tmesh.numfaces > 0) then (
						
							-- asign filename ass obj name
							
							local ObjFileName = SavePath + "/" + obj.name + ".dda"
							
							
							ChkNameNew = (filterString obj.name "! @ # $ % ^ & * - + = | \ { } [ ] ( ) ~ ` / . , < >" splitEmptyTokens:true)
							
							
							
							
							-- chek wrong obj names and if "undefined" skip to processing
							if (ChkNameNew.count != 1) then
							(
								
								if (chkWarn.checked == false) then
								(
									messagebox ("Object wiht name \"" + obj.name + "\" has a Bad Name! Use standart Symbols and numbers only(A-Z,a-z,0-9). Skip to processing...") title: "Warning!"
								)
							)
							-- Object name is corect 
							else
							(
							
							-- Check for Existing objects whit duplicate names in The Scene
							ChkFile = 0
							
							for NmObj in selection do (
								
								if (NmObj.name == obj.name) then (ChkFile = ChkFile +1)
								
							)
							-- if file not exist then processing next step else warning and skip object to export
							if ( ChkFile == 1 ) then
							(
								-- Check Obj BBox Size and if > 99 999 Warning and skip obj to export
								-------------------------
								BBoxSize = true -- By default Bounding Box Size is corect
								
								for v = 1 to tmesh.numverts do (
									
									vert = getVert tmesh v
									if (vert.x > 10000 or vert.x < -10000 or vert.y > 10000 or vert.y < -10000 or vert.z > 10000 or vert.z < -10000) then
									(
										BBoxSize = false -- BBox Size is to big
									)
									
								)
								
								-------------------------
								if (BBoxSize == true) then
								(
								-- check for UV coordinates present. If not exist scip object to export
									if (tmesh.numtverts != 0) then
									(
									-- Check for ASCII Export
									if (chkASC.checked == true) then
									
									(

									local ObjFile = Createfile ObjFileName
							
									format "%\n" "DDDA 1.0 # DDA file, version=1.0"  to:ObjFile
									format "%\n" "# this must be the first bytes of the file"  to:ObjFile
									format "%\n" ""  to:ObjFile
							
									local VrtCOunt = (tmesh.numtverts as string) + " # tex count - number of texture coordinates"
							
									format "%\n" VrtCOunt to:ObjFile
							
									-- Vertex UV export
							
									for i = 1 to tmesh.numtverts do (
							
										tv = (GetTVert tmesh i)
										format "% "  tv.x to:ObjFile
										format "%\n"  (-1*tv.y) to:ObjFile
										
										--Update Progress Bar Info
										pbCurrent.value = 100.*i/tmesh.numtverts
										lblPercentS.caption = "UVW Vertex " + pbCurrent.value as string +"%"
								
									) 
									
									pbCurrent.value = 0
									
									format "%\n" "" to:ObjFile
							
									-- Write Numbers of Faces in current Object
									local FaceCountW = (tmesh.numfaces as string) + " # number of faces"
									format "%\n" FaceCountW  to:ObjFile
									format "%\n" "# face description" to:ObjFile
							
									-- Get material Diffuse Color an write to output
									FaceColor = obj.material.DiffuseColor as string
									FColor = filterString FaceColor "color ( )"
							
							
									-- Export Face Index
									for f = 1 to tmesh.numfaces do
									(
								
										format "% % % # rgb for this face\n" FColor[1] FColor[2] FColor[3] to:ObjFile
								
										face = (getFace tmesh f) as string
										FilteredFace = filterString face ",[]"
								
										x = FilteredFace[1] as integer
										x = x-1
										y = FilteredFace[2] as integer
										y = y-1
										z = FilteredFace[3] as integer
										z = z-1
										
										--Chek for vertex UV present. If not exist(==0) then write face UV indexes 0,0,0
										if (tmesh.numtverts != 0) then
										(										
											Tface = (getTVFace tmesh f)
									
											--FilteredTFace = filterString Tface ",[]"
								
											Tx = (Tface.x - 1) as integer
											Ty = (Tface.y - 1) as integer
											Tz = (Tface.z - 1) as integer
										)
										else
										(
											Tx = Ty = Tz = "0"
										)
										
										format "3 % % % % % %\n" x Tx y Ty z Tz   to:ObjFile
										
										--Update Progress Bar Info
										pbCurrent.value = 100.*f/tmesh.numfaces
										lblPercentS.caption = "Face Index " + pbCurrent.value as string +"%"
								
									)
									
									pbCurrent.value = 0
									
									-- Calculate Total Animation Frames
									format "%\n" "" to:ObjFile
									NFrames = ((abs(animationRange.start) +AnimEnd)/NthFrame.value)
									NFrames = int (NFrames) + 1
									format "% #number of keyframes\n" NFrames to:ObjFile
									format "%\n" "" to:ObjFile
							
									-- export anumated vertex position as frames
									format "%\n" "# keyframe description" to:ObjFile
							
									for i = animationRange.start to AnimEnd by NthFrame.value do
									(	
										local tmesh = snapshotAsMesh obj
									
									
										sliderTime = i
									
										-- Export Vertex positions
										local VertexCountW = (tmesh.numverts as string) + " # number of position vertices for keyframe " + ( int(i) as string) 
										format "%\n" VertexCountW to:ObjFile
								
										for v = 1 to tmesh.numverts do
										(
											vert = getVert tmesh v as string
											FilteredVert = filterString vert ",[]"
											format "% % %\n " FilteredVert[1] FilteredVert[2] FilteredVert[3] to:ObjFile
										
										)
								
										format "%\n" "" to:ObjFile
										format "%\n" "# next keyframe" to:ObjFile
										--exportFile (SavePath +"\\"+ (i as string) + ".3ds") #noPrompt
										pbCurrent.value = 100.*i/AnimEnd
										lblPercentS.caption = "Vertex Frame " + pbCurrent.value as string +"%"
						
										
									)
									
									close ObjFile
									delete tmesh
									
									)
									else
									--Binary Export Mode
									(
											-- temporary binary Export
									-- Create File 
									local BObjFileName = SavePath + "/" + obj.name + ".ddd"
									local BObjFile = fopen BObjFileName "wb" 
									
									-- Write Header
									--file type
									writelong BObjFile 13021975
										
									-- file version
									writedouble BObjFile 2.0
										
									--number animation frames
									NFrames = ((abs(animationRange.start) +AnimEnd)/NthFrame.value)
									NFrames = int (NFrames) + 1
									writelong BObjFile NFrames
									
									--number of used colors
									writelong BObjFile 2
									
									--number of UV PAirs(x,y) Coordinates
									writelong BObjFile (tmesh.numfaces*4)
									
									--write Diffuse color Current object 0x00BBGGRR
									for i = 1 to 4 do
									(
										writebyte BObjFile 255
									)
									
									local FaceColor = obj.material.DiffuseColor as string
									local FColor = filterString FaceColor "color ( )"
									
									
									for i = 1 to 3 by 1 do
									(
										local a = FColor[i] as float
										writebyte BObjFile a
									)
									writebyte BObjFile 0
									
									--write Tex coordinates as float
									
									for i = 1 to tmesh.numfaces do
									(	
										-- add some "magic" numbers by design DDD format
										writefloat BObjFile 0
										writefloat BObjFile 0
										
										-- geting indexes of vertex current face
										face = (getTVFace tmesh i) as string
										FilteredFace = filterString face ",[]"

										for f = 1 to 3 do
										(	
											gv = FilteredFace[f] as integer
											tv = (GetTVert tmesh gv)
											writefloat BObjFile (tv.x)
											writefloat BObjFile (tv.y)
										
										)
									)
									
									
									
									-- Export Every vertex frames
									for i = 0 to AnimEnd by NthFrame.value do
									(	
										local tmesh = snapshotAsMesh obj
										sliderTime = i
										
										--number of UV PAirs(x,y) Coordinates AGAIN
										writelong BObjFile (tmesh.numfaces*4)
										
										--Write every frame (vertex position, normal index, color table index)
		
										for a = 1 to tmesh.numfaces do
										(
											-- add some "magic" numbers by design DDD format
											writefloat BObjFile 0
											writefloat BObjFile 0
											writefloat BObjFile 0
													
											writebyte BObjFile 0
											writebyte BObjFile 0
												
											-- geting indexes of vertex current face
											face = (getFace tmesh a) as string
											FilteredFace = filterString face ",[]"
											for f = 1 to 3 do
											(	
												gv = FilteredFace[f] as integer
												tv = (GetVert tmesh gv)
											
											
												
												writefloat BObjFile tv.x
												writefloat BObjFile tv.y
												writefloat BObjFile tv.z
												
												
												--write normal index current vertex
												OldVal = 1000
												for s = 1 to NList.count by 3 do
													
												(
													ANormal  = GetNormal tmesh gv
													--FilteredNormal = filterString ANormal ",[]"
													
													--xo = FilteredNormal[1] as float
													--yo = FilteredNormal[2] as float
													--zo = FilteredNormal[3] as float
													ATNormal = [Nlist[s] , Nlist[s+1] , Nlist[s+2]]
													NewVal = distance ANormal ATNormal
													--print NewVal
													
													if NewVal < OldVal then
													(
														global Uptd = s
														OldVal = NewVal
													
													)
													--NList #(s)
													
												)
												
												writebyte BObjFile (Uptd/3 as integer )
												
												--write color table index current vertex(alvays 1 because color table have one color)
												writebyte BObjFile 1
											)
											
											
											--Update Progress Bar Info
											pbCurrent.value = 100.*a/tmesh.numfaces
											lblPercentS.caption = "Normals Calc. " + pbCurrent.value as string +"%"	
										
										)
										
										--Update Progress Bar Info
										--pbTotal.value = 100.*i/AnimEnd
										--lblPercentT.caption = "Frames " + pbTotal.value as string +"%"	
										
										pbCurrent.value = 0
										lblPercentS.caption = "Done!"
									)
									
									--pbTotal.value = 0
									--lblPercentT.caption = "Done!"
									
									fclose BObjFile
									
									delete tmesh
								--Binary Export End
									)
									
										-- Add texture path(if exist else "undefined") to array for future use(*.ddw)
										-- Check for avilable map in slot
									if (obj.material.diffusemap != undefined) then
									( 	
										-- Check for type of assigned Map in to slot and skip if "non BitMap"
										Map = obj.material.diffusemap as string
										MapType = Filterstring Map ":"
										if (MapType[2] == "Bitmap") then
										(	
											-- Check for valid bitmap name
											if (obj.material.diffusemap.filename != "") then
											(	-- add to objects list array texture name
												join SObjDiff #(obj.material.diffusemap.filename)
													
												-- exclude from array for saving, duplicated textures(minimize Copy Time)
												if ((findItem STex obj.material.diffusemap.filename) == 0 ) then
												(
													join STex #(obj.material.diffusemap.filename)
													
												)
											)
											else
											(
												join SObjDiff #("-1")
											)
										)
										else
										(	
											join SObjDiff #("-1")
											if (chkWarn.checked == false) then
											(
												messagebox ("Bad MapType in \"Diffuse Color\" Slot! Material name is \"" + obj.material as string + "\"!. Use Default \"None\"")  title: "Warning!"
											)
										)
									)
									else
									(
										join SObjDiff #("-1")
									)
									
									-- Repeat all for "Bump" Slot
									if (obj.material.bumpmap != undefined) then
									(
										
										Map = obj.material.bumpmap as string
										MapType = Filterstring Map ":"
										if (MapType[2] == "Bitmap") then
										(	
											if (obj.material.bumpmap.filename != "") then
											(
												join SObjBump #(obj.material.bumpmap.filename)
											
												if ((findItem STex obj.material.bumpmap.filename) == 0 ) then
												(
													join STex #(obj.material.bumpmap.filename)
												)
											)
											else
											(
												join SObjBump #("-1")
											)
										)
										else
										(
											join SObjBump #("-1")
											
											if (chkWarn.checked == false) then
											(
												messagebox ("Bad MapType in \"Bump\" Slot! Material name is \"" + obj.material as string + "\"!. Use Default \"None\"")  title: "Warning!"
											)
											
										)		
									)
									else
									(
										join SObjBump #("-1")
									)
									
									-- add good Objects to list
									join SObjNm #(Obj.name)
									
									
									EnableSceneRedraw
									
							
							
									pbCurrent.value = 0
									lblPercentS.caption = "0%"
								)	
								else
								(
									if (chkWarn.checked == false) then
									(
										messagebox (" Object \"" + obj.name + "\" not have Mapping Coordinates! Assign UV Map Modifer. Skip to processing...") title: "Warning!"
									)
								
								)
								
								)
								
								else
								(
									if (chkWarn.checked == false) then
									(
										messagebox (" Boundig Box Size \"" + obj.name + "\" to large! Must be <10.000(x,y,z) Skip to processing...") title: "Warning!"
									)
								
								)
							)
							else
							(
								if (chkWarn.checked == false) then
								(
									messagebox (" Duplicate Objects name \"" + obj.name + "\" in the Scene! Skip to processing...") title: "Warning!"
								)
							)
						
						
						
						)
						)
						else (
							if (chkWarn.checked == false) then
							(
								messagebox ("Object with name \"" + obj.name + "\" not have faces! Fix it!") title: "Warning!"
							)
						)
						)
						else (
							if (chkWarn.checked == false) then
							(
								messagebox ("Object with name \"" + obj.name + "\" not have \"Standart\" Type of Material(Now is \""+MtlName + "\") ! Skip to processing...") title: "Warning!"
							)
						)
						)
						else (
							if (chkWarn.checked == false) then
							(
							messagebox ("Object wiht name \"" + obj.name + "\" not assign any Material! Skip to processing...") title: "Warning!"
							)
						)
					)
					
					-- Check for Present Objects in the scene
					-- and skip Copy Textures and make DDW if not exist any Object
					if (SObjNm.count != 0) then
					(
						-- if "Copy Textures" cheked 
						if ( chkCopy.checked == true) then
						(
							-- Copy textures to exported files if need
							
							for i = 1 to STex.count do
							(	
								DesName = SavePath +"\\" +(filenameFromPath STex[i])
								CopyFile STex[i]  DesName
								
								-- Update ProgressBar
								pbCurrent.value = 100.*i/STex.count
								lblPercentS.caption = "Textures " + pbCurrent.value as string +"%"
							)
							
							pbCurrent.value = 0
							lblPercentS.caption = "Done!"
						)
						-- Create DDW file if need
						if ( chkWrld.checked == true) then
						(	
					
						
							-- Check for saving scene before Export Process
							DDWFileName = trimRight maxFileName ".max"
						
							if (DDWFileName != "") then
							(
							DDWFileName = SavePath + "\\" + DDWFileName + ".ddw"
				
							local DDWFile = Createfile DDWFileName
								
							
								
								--Start file
								format "%\n%\n" ";DDW1.0" "[objects]"  to:DDWFile
								
								--Write Objects count in the Scene
								ObjNum = SObjNm.count as string
								format "%%\n" ObjNum " ; Number of objects"  to:DDWFile
								
								-- Save Object name
								for i = 1 to SObjNm.count do
								(	
									ObjNrm = i as string
									ObjNm = SObjNm[i] as string
									
									--Select Extension 
									if (chkASC.checked == true ) then Extens =".dda" else Extens =".ddd"
									
									format "%%%%\n" ObjNrm "=" ObjNm Extens to:DDWFile
									
									
									IdxD = "-1"
									IdxB = "-1"
									for f = 1 to STex.count do
									(	--Search Texture index in Texturelist
										
										if (SObjDiff[i] == STex[f] ) then IdxD = f as string -- and return index of DiffuseTexture strig if founded.
										if (SObjBump[i] == STex[f] ) then IdxB = f as string -- and return index of BumpTexture strig if founded.
										
									)
									
									format "%%%%\n" "ta" i "=" IdxD to:DDWFile
									format "%%%%\n" "tb" i "=" IdxB to:DDWFile
									
									format "\n" to:DDWFile
								)
								
								TCount = STex.count as string
								format "%\n%%\n" "[textures]" "count=" TCount to:DDWFile
								
								for i = 1 to STex.count do
								(
									TName = filenameFromPath STex[i] 
									format "%%%\n" (i as string) "=" TName to:DDWFile
								)
							close DDWFile
								
							)
							else
							(
								if (chkWarn.checked == false) then
								(
									messagebox ("Save Scene before Export or uncheck \"Export World File\"") title: "Warning!"
								)
							)
						)
					)
					
				)
			else
				(
					if (chkSObj.checked == false)
					then
					(
						if (chkWarn.checked == false) then
						(
							messagebox "Scene Empty! Please create Objects!"
						)
					)
					else
					(
						if (chkWarn.checked == false) then
						(
							messagebox "You must have at least one Object selected!"
						)
					)
				)
				
			
			
			)
			
		--RECURSIVE File List FUNCTION
		fn getFilesRecursive root pattern =

		(

		dir_array = GetDirectories (root+"/*")

		for d in dir_array do

		join dir_array (GetDirectories (d+"/*"))

 

		my_files = #()

		for f in dir_array do

		join my_files (getFiles (f + pattern))


		my_files 

		)

		-- FUNCTIONS to Select paths for BatchExport Mode
		fn SInput = (
	
			OpenPath = getSavePath caption:"Select Input Directory:" initialDir:(getDir #export)
				if (OpenPath == undefined) then (
					OpenPath = #export
					edtInput.text = "Default 3DSMax Export Directory..."
				)
				else(
					edtInput.text = OpenPath
				)
		)
		
		fn SOutput =(
			
				SavePath = getSavePath caption:"Select Output Directory:" initialDir:(getDir #export)
				if (SavePath == undefined) then (
					SavePath = #export
					edtOutput.text = "Default 3DSMax Export Directory..."	
				)
				else (
					edtOutput.text = SavePath
				)
		)
		-- Change\Select Bachexport Paths
		on btnInput pressed do (
			--SInput()
			OpenPath = SInput()
				
		)
		on btnOutput pressed do (
			--SOutput()
			SavePath = SOutput()
				
		)	
		-- Main export start Hire!
		on btnExport pressed do
			(
			-- Check for Batc\Single Scene Export Mode.
			
			if (chkBachExp.checked == false) then (
				
				if (SavePath == undefined or SavePath == "undefined") then SavePath = SOutput()
	
				-- Single Scene Export
				MainExport()
				-- Reset Progress "Total" Bar
				pbCurrent.value = 0
				lblPercentS.caption = "Done!"
				clearSelection()
				
				enableSceneRedraw()
			)
			
			else (
				-- Batch export
				-- Check for Path asigment
				
				if (OpenPath == undefined or OpenPath == "undefined") then OpenPath = SInput()
				if (SavePath == undefined or SavePath == "undefined") then SavePath =SOutput()
				
			
				--collect all max files in the dir.
				if (chkSubFldr.checked == false) then (
					
					FileList = getFiles (OpenPath +"\\*.max") 
				)
				else (
					
				FileList = getFilesRecursive OpenPath "*.max"
				)
				--BarCounter = (getFiles OpenPath +"\\*.max").count
				--if List of *.max files containing duplicate filenames - abort Batch export
				
				for i in FileList do
				(
					
					
				)
				
				
				
				local PBarB = 1
				for CurrentFile in FileList do (
				
					--load the next file
					pbTotal.value = 100.*PBarB/FileList.count
					lblPercentT.caption = pbTotal.value as string + "%"
					loadMaxFile CurrentFile
						PBarB = PBarB +1
					MainExport()
				)
				-- Reset Progress "Total" Bar
				pbTotal.value = 0
				lblPercentT.caption = "Done!"
				
				 --at the end reset Scene and Skip Selection if exist
				clearSelection()
				enableSceneRedraw()
				resetMaxFile #noPrompt
			)
		)
		
	
)

		-- finish interface annd prepare to setup Settings
fn WriteToFile LabelStr =(
		local IniFileName = (GetDir #startupScripts) + "/GLBasic.ini"
	
		if ((getfiles IniFilename).count == 0) then (

			--ini file not exist create default settings
	
			IniFile = createfile IniFileName
			format "%\n" chkASC.checked  to:IniFile


			
			close IniFileName
			)
		else (

		-- ini file exist and read settings from it
	
		)
	)

createDialog ExportGLBasic 200 584



)

-- macroscript GlBasicInterface buttontext:"GLBasicInterface" category:"GLBasicInterface" ( )

(




local mainMenu = menuMan.getMainMenuBar()

local subMenu = menuMan.createMenu "GLBasicTools"
	
local myItem = menuMan.createActionItem "GLBasicExport" "GLBasic"

myItem.setTitle "Export..."
myItem.setUseCustomTitle true

subMenu.addItem myItem -1

local myItem1 = menuMan.createActionItem "GLBBox" "GLBasic"
myItem1.setTitle "Collision Generator..."
myItem1.setUseCustomTitle true

subMenu.addItem myItem1 -1

local subMenuItem = menuMan.createSubMenuItem "GLBasicTools" subMenu

local exportSelectedIndex
local addItem = true
for i = 1 to (mainMenu.numItems()) do (
local item = mainMenu.getItem i
local itemTitle = item.getTitle()
if (itemTitle == "GLBasicTools") then ( addItem = false; exit )
else if (itemTitle == "Help" or itemTitle == "&Help") then ( exportSelectedIndex = i )

)
if (addItem AND (exportSelectedIndex != undefined)) then (
mainMenu.addItem subMenuItem (exportSelectedIndex+1)
)
menuMan.updateMenuBar()
)